; DAC-sampler written by Rune on 2000-06-20 from SRC-file created from original C-layout
;
;; DAC.SRC generated from: DAC.C

$NOMOD51

NAME	DAC

; declare all the ports needed for sampling, P4 and P5 bitaddressible and DAC_INIT, DAC_PULSE, DAC_IN1, DAC_IN2 for sampling
P4			DATA	0E8H
P4_0		BIT	0E8H.0
P4_1		BIT	0E8H.1
P4_2		BIT	0E8H.2
P4_3		BIT	0E8H.3
P4_4		BIT	0E8H.4
P4_5		BIT	0E8H.5
P4_6		BIT	0E8H.6
P4_7		BIT	0E8H.7
P5			DATA	0F8H
P5_0		BIT	0F8H.0
P5_1		BIT	0F8H.1
P5_2		BIT	0F8H.2
P5_3		BIT	0F8H.3
P5_4		BIT	0F8H.4
P5_5		BIT	0F8H.5
P5_6		BIT	0F8H.6
P5_7		BIT	0F8H.7
DPH		DATA	083H
DPL		DATA	082H

DAC_CS		BIT	0F8H.0
DAC_PULSE	BIT	0F8H.1
DAC_IN1		BIT	0F8H.2
DAC_IN2		BIT	0F8H.3

B		DATA    0F0H


?PR?dac_init?DAC		SEGMENT CODE
?PR?_dac_input?DAC		SEGMENT CODE
?PR?_dac_output?DAC	SEGMENT CODE



; Declare external (EXTRN) functions and exports (PUBLIC)
; EXTRN's must be declared in order to call the methods
	EXTRN	CODE (?C?ISTPTR)
	EXTRN	CODE (?C?ILDPTR)
	PUBLIC	dac_init
	PUBLIC	_dac_input
	PUBLIC	_dac_output
	

; _dac_init:
; 
; Initialise ports for A/D

	RSEG  ?PR?dac_init?DAC
	USING	1

dac_init:
	SETB	DAC_IN1
	SETB	DAC_IN2
	RET
	


; _dac_input: void dac_input( struct dac_samplepair *pair )
;         -> pointer to pair
;         <- none, updates memory pointet to by pair
;
; Samples both A/D converters on the test-board
;
; For the sake of speed, this function needs to be implemented in assembler (takes up 67% of calc interrupt time ~400 cycles)
; Calculation says that the theoretical lowest time is around 2*6 + 12*(6[pulse]+4[copy]+2[loop]) = 156 cycles... half the execution time...
; 
; On entry: R3    : memory specification for generic pointer (0=DATA, 1=XDATA. 0xFF=CODE)
;           R2,R1 : high(R2)- and low(R1)-byte of address
;
	RSEG  ?PR?_dac_input?DAC
	USING	1
_dac_input:

	; set timing bit (P4.1)
;	SETB 	P4_1
	
	; clear dac-pulse
	CLR  	DAC_PULSE
	
	; clear DAC_CS (/CS on chip)
	CLR  	DAC_CS
	
	; send two init pulses, each pulse must have a length of 3 usec. Meanwhile reset R4->R7
	SETB 	DAC_PULSE
	CLR	A
	MOV	R4, A
	CLR  	DAC_PULSE
	MOV	R5, A
	MOV	R6, A
	SETB 	DAC_PULSE
	MOV	R7, A
	NOP
	CLR  	DAC_PULSE
	NOP
	;NOP

   ; set R0 to 4 as loop-counter for the upper 4 bits
	MOV	R0, #4
LP_UPPER4:                                        ; 15 cycles pr. loop
	; pulse and rotate, need accumulator for that  
	SETB	DAC_PULSE                                ; 1
	NOP                                            ; 1
 	;-NOP                                            ; 1
	CLR	DAC_PULSE                                ; 1
	;-NOP                                            ; 1
	;-NOP                                            ; 1
		
	; read from dac1 to carry
	XCH	A, R4                                    ; 1
	MOV	C, DAC_IN1                               ; 1
	RLC	A                                        ; 1
	XCH	A, R4                                    ; 1
	
	; read from dac2 to carry
	XCH	A, R5                                    ; 1
	MOV	C, DAC_IN2                               ; 1
	RLC	A                                        ; 1
	XCH	A, R5                                    ; 1
	
	DJNZ	R0, LP_UPPER4                            ; 2


	; enter a loop with 8 runs for the lower 8 bits of the result. These bits are stored in  R6 and R7
	MOV	R0, #8
LP_LOWER8:
	; pulse and rotate, need accumulator for that  
	SETB	DAC_PULSE                                ; 1
	NOP                                            ; 1
	;-NOP                                            ; 1
	CLR	DAC_PULSE                                ; 1
	;-NOP                                            ; 1
	;-NOP                                            ; 1
		
	; read from dac1 to carry
	XCH	A, R6                                   ; 1
	MOV	C, DAC_IN1                               ; 1
	RLC	A                                        ; 1
	XCH	A, R6                                   ; 1
	
	; read from dac2 to carry
	XCH	A, R7                                   ; 1
	MOV	C, DAC_IN2                               ; 1
	RLC	A                                        ; 1
	XCH	A, R7                                   ; 1
	
	DJNZ	R0, LP_LOWER8                            ; 2
	
	
	
	
	; subtract 2048 from the samples values (need only subtracting in high-byte since low-byte of 2048 is zero)
	XCH	A, R4
	CLR	C
	SUBB	A, #8
	XCH	A, R4
	XCH	A, R5
	CLR	C
	SUBB	A, #8
	XCH	A, R5
	
	; store the samples into "pair" - first store on address, add 2 and store second sample
	MOV	A, R4
	MOV	B, R6
	LCALL	?C?ISTPTR
	MOV	A, R1
	ADD	A, #2
	MOV	R1, A
	MOV	A, R2
	ADDC	A, #0
	MOV	R2, A
	MOV	A, R5
	MOV	B, R7
	LCALL	?C?ISTPTR

	; release /CS
	SETB	DAC_CS

	; clear timing bit
;	CLR	P4_1
	
	; the end of dac_input
	RET






; _dac_output: void dac_output( struct dac_samplepair *pair )
;         -> pointer to pair
;         <- none
;
; Sets both D/A converters on board
;
; On entry: R3    : memory specification for generic pointer (0=DATA, 1=XDATA. 0xFF=CODE)
;           R2,R1 : high(R2)- and low(R1)-byte of address
;
	RSEG  ?PR?_dac_output?DAC
	USING	1
_dac_output:

	; set timing bit (P4.1)
;	SETB 	P4_1
	
   ; load samples and correct for bias (+2048) into (R4, R5) and (R6, R7) 
   LCALL	?C?ILDPTR ; returns low-byte in A and high-byte in B
   XCH		A, B
   ADD		A, #8
   MOV		R4, A
	MOV		R6, B
   MOV		A, R1
   ADD		A, #2
   MOV		R1, A
   MOV     A, R2
   ADDC    A, #0
	MOV     R2, A
   LCALL   ?C?ILDPTR
   XCH		A, B
   ADD		A, #8
   MOV		R5, A
   MOV		R7, B
	
   ; prepare DPTR
   MOV		A, #0FBH
   MOV		DPH, A
   MOV		A, #0F0H
   MOV		DPL, A
   
   ; store low-byte dac1
   MOV		A, R6
   MOVX	@DPTR, A
   
   ; store high-byte dac1, we know that DPL=F0h
   INC		DPL
   MOV		A, R4
   MOVX	@DPTR, A
   
   ; make dummy read and set pointer at DPTR=FBF2
   DEC		DPL
   MOVX	A, @DPTR
   INC		DPL
   INC		DPL
   
   ; store low-byte dac2, we know that DPL=F1h
   MOV		A, R7
   MOVX	@DPTR, A

   ; store high-byte dac2, we know that DPL=F2h
   INC		DPL
   MOV		A, R5
   MOVX	@DPTR, A
   
   ; make dummy reading from FBF2
   DEC		DPL
   MOVX	A, @DPTR

	; clear timing bit (P4.1)
;	CLR		P4_1
	
   ; return from sub-routine
   RET
   
END

